"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _os = require("os");

var _child_process = require("child_process");

var _lodash = require("lodash");

var _fsExtra = require("fs-extra");

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _moment = require("moment");

var _moment2 = _interopRequireDefault(_moment);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _debug = require("./debug");

var debug = _interopRequireWildcard(_debug);

var _Github = require("./Github");

var _Github2 = _interopRequireDefault(_Github);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Version = function () {
  function Version(config, options) {
    var _incrementMap;

    (0, _classCallCheck3.default)(this, Version);

    this.config = config;
    this.options = (0, _extends3.default)({}, Version.defaultOptions, options);

    this.incrementMap = (_incrementMap = {}, (0, _defineProperty3.default)(_incrementMap, this.config["major-label"], Version.INCREMENT_MAJOR), (0, _defineProperty3.default)(_incrementMap, this.config["minor-label"], Version.INCREMENT_MINOR), (0, _defineProperty3.default)(_incrementMap, this.config["patch-label"], Version.INCREMENT_PATCH), _incrementMap);

    var branch = Version.getBranch();

    // force dry-run when not on the release-branch and !this.options.init
    if (!this.options.init && branch !== this.options.branch) {
      this.options.dryRun = true;
    }

    debug.info("Current branch: %s", branch);
    debug.info("Release branch: %s", this.options.branch);

    this.shouldPush = this.options.push || this.options.publish;
    this.shouldPublish = this.options.publish;

    if (this.options.dryRun) {
      debug.info("Dry-run enabled");
    }

    if (this.shouldPush) {
      debug.info("Version updates will be pushed to the repo");
    }

    if (this.shouldPublish) {
      debug.info("Version updates will be published to NPM");
    }
  }

  (0, _createClass3.default)(Version, [{
    key: "getLastChangeWithIncrement",


    // returns the PR or commit with the increment level attached
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var pr, commitSHA, githubapi, commit;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pr = Version.getLastPullRequest();

                if (pr) {
                  _context.next = 10;
                  break;
                }

                debug.warn("Only commits found. Defaulting to " + Version.INCREMENT_PATCH + ".");
                commitSHA = Version.getLastCommit();

                // get the last commit from github

                githubapi = new _Github2.default(Version.getUserRepo());
                _context.next = 7;
                return githubapi.getCommit(commitSHA);

              case 7:
                commit = _context.sent;

                commit.increment = Version.INCREMENT_PATCH;

                return _context.abrupt("return", commit);

              case 10:
                _context.next = 12;
                return this.getIncrementFromPullRequest(pr);

              case 12:
                return _context.abrupt("return", _context.sent);

              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getLastChangeWithIncrement() {
        return _ref.apply(this, arguments);
      }

      return getLastChangeWithIncrement;
    }()

    // returns a pull request with increment level noted

  }, {
    key: "getIncrementFromPullRequest",
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(number) {
        var githubapi, prDetails, increment;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                githubapi = new _Github2.default(Version.getUserRepo());
                _context2.next = 3;
                return githubapi.getPullRequest(number);

              case 3:
                prDetails = _context2.sent;
                _context2.next = 6;
                return githubapi.getIssueLabels(number);

              case 6:
                prDetails.labels = _context2.sent;

                if (prDetails.labels) {
                  _context2.next = 11;
                  break;
                }

                debug.warn("No labels found on PR #" + number + ". Defaulting to " + Version.INCREMENT_PATCH + ".");
                prDetails.increment = Version.INCREMENT_PATCH;

                return _context2.abrupt("return", prDetails);

              case 11:
                increment = this.getIncrementFromIssueLabels(prDetails);

                if (!increment) {
                  _context2.next = 16;
                  break;
                }

                debug.info("Found " + increment + " label on PR #" + number + ".");
                prDetails.increment = increment;

                return _context2.abrupt("return", prDetails);

              case 16:

                debug.warn("No labels found on PR #" + number + ". Defaulting to " + Version.INCREMENT_PATCH + ".");
                prDetails.increment = Version.INCREMENT_PATCH;

                return _context2.abrupt("return", prDetails);

              case 19:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getIncrementFromPullRequest(_x) {
        return _ref2.apply(this, arguments);
      }

      return getIncrementFromPullRequest;
    }()
  }, {
    key: "increment",
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
        var lastChange, cmd, branch, newVersion, range, commit, _commit$split, _commit$split2, name, email, message, appendSuccess;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.getLastChangeWithIncrement();

              case 2:
                lastChange = _context3.sent;
                cmd = "npm version " + lastChange.increment + " --no-git-tag-version";
                branch = Version.getBranch();
                newVersion = Version.incrementVersion(lastChange.increment, this.config.version);


                debug.info("Bumping v" + this.config.version + " with " + lastChange.increment + " release...");

                // override the git user/email based on last commit

                if (!(process.env.CI && !this.options.dryRun)) {
                  _context3.next = 18;
                  break;
                }

                range = Version.getCommitRange();
                commit = Version.exec("git log -n1 --format='%an|%ae|%s' " + range).shift();

                if (commit) {
                  _context3.next = 13;
                  break;
                }

                debug.warn("No merge commits found between: %s", range);
                throw new Error("No commits found in " + range);

              case 13:
                _commit$split = commit.split("|"), _commit$split2 = (0, _slicedToArray3.default)(_commit$split, 3), name = _commit$split2[0], email = _commit$split2[1], message = _commit$split2[2];


                debug.info("Overriding user.name to " + name);
                Version.exec("git config user.name \"" + name + "\"");

                debug.info("Overriding user.email to " + email);
                Version.exec("git config user.email \"" + email + "\"");

              case 18:

                if (this.shouldPush && !this.options.dryRun) {
                  Version.exec("git checkout " + branch);
                }

                if (!this.options.dryRun) {
                  Version.exec(cmd, { stdio: "ignore" });
                } else {
                  debug.warn("[DRY RUN] Executing " + cmd);
                }

                if (this.shouldPush && !this.options.dryRun) {
                  Version.exec("git add package.json");
                }

                if (this.options.changelog) {
                  appendSuccess = true;

                  try {
                    this.appendChangeLog(newVersion, lastChange);
                  } catch (err) {
                    debug.warn("Skipping appending to CHANGELOG -- no current CHANGELOG.md found.");
                    appendSuccess = false;
                  }

                  if (appendSuccess && this.shouldPush && !this.options.dryRun) {
                    Version.exec("git add CHANGELOG.md");
                  }
                }

                if (this.shouldPush && !this.options.dryRun) {
                  Version.exec("git commit -m \"Automated release: v" + newVersion + "\n\n[ci skip]\"");
                  Version.exec("git tag v" + newVersion);
                }

              case 23:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function increment() {
        return _ref3.apply(this, arguments);
      }

      return increment;
    }()
  }, {
    key: "publish",
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        var cmd;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                cmd = "npm publish";

                if (!this.config.private) {
                  _context4.next = 3;
                  break;
                }

                return _context4.abrupt("return", debug.warn("Private package! Skipping " + cmd + "..."));

              case 3:
                if (!this.options.dryRun) {
                  _context4.next = 5;
                  break;
                }

                return _context4.abrupt("return", debug.warn("[DRY RUN] " + cmd));

              case 5:

                if (process.env.CI && process.env.NPM_TOKEN) {
                  debug.info("Writing NPM_TOKEN to ~/.npmrc...");
                  Version.exec('echo "//registry.npmjs.org/:_authToken=${NPM_TOKEN}" > ~/.npmrc');
                }

                Version.exec(cmd);

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function publish() {
        return _ref4.apply(this, arguments);
      }

      return publish;
    }()
  }, {
    key: "push",
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
        var _Version$getUserRepo, user, repo, token, origin, cmd;

        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (process.env.CI && process.env.GH_TOKEN) {
                  _Version$getUserRepo = Version.getUserRepo(), user = _Version$getUserRepo.user, repo = _Version$getUserRepo.repo;
                  token = '${GH_TOKEN}';
                  origin = "https://" + user + ":" + token + "@github.com/" + user + "/" + repo + ".git";


                  debug.info("Explicitly setting git origin to: " + origin);

                  Version.exec("git remote set-url origin " + origin);
                }

                cmd = "git push origin master --tags";


                if (this.options.dryRun) {
                  debug.warn("[DRY RUN] Executing " + cmd);
                } else {
                  Version.exec(cmd, { stdio: "ignore" });
                }

              case 3:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function push() {
        return _ref5.apply(this, arguments);
      }

      return push;
    }()
  }, {
    key: "getPullRequestCommits",
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(prs) {
        var _this = this;

        var githubapi, prCommits;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                githubapi = new _Github2.default(Version.getUserRepo());
                prCommits = prs.map(function () {
                  var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(pr) {
                    var commits;
                    return _regenerator2.default.wrap(function _callee6$(_context6) {
                      while (1) {
                        switch (_context6.prev = _context6.next) {
                          case 0:
                            _context6.next = 2;
                            return githubapi.getCommitsFromPullRequest(pr.number);

                          case 2:
                            commits = _context6.sent;
                            return _context6.abrupt("return", [].concat((0, _toConsumableArray3.default)(commits)));

                          case 4:
                          case "end":
                            return _context6.stop();
                        }
                      }
                    }, _callee6, _this);
                  }));

                  return function (_x3) {
                    return _ref7.apply(this, arguments);
                  };
                }());
                return _context7.abrupt("return", _promise2.default.all(prCommits));

              case 3:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function getPullRequestCommits(_x2) {
        return _ref6.apply(this, arguments);
      }

      return getPullRequestCommits;
    }()
  }, {
    key: "getRepoTimeline",
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8() {
        var githubapi, allIssues, allCommits, allPRCommits, independentCommits, theTimeline;
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                if (!this.timeline) {
                  _context8.next = 2;
                  break;
                }

                return _context8.abrupt("return", this.timeline);

              case 2:
                githubapi = new _Github2.default(Version.getUserRepo());

                debug.info("Fetching all merged pull requests for the repo...");
                _context8.next = 6;
                return githubapi.searchIssues({ state: "closed", type: "pr", is: "merged" });

              case 6:
                allIssues = _context8.sent;

                debug.info("Merged pull requests fetched: " + allIssues.length);
                debug.info("Fetching all commits for the repo (yep, ALL commits)...");
                _context8.next = 11;
                return githubapi.getCommitsFromRepo();

              case 11:
                allCommits = _context8.sent;

                debug.info("Commits fetched: " + allCommits.length);

                // populate the commits for each pull request
                debug.info("Fetching the commits associated with the pull requests.");
                _context8.next = 16;
                return this.getPullRequestCommits(allIssues);

              case 16:
                _context8.t0 = _context8.sent;
                allPRCommits = (0, _lodash.flattenDeep)(_context8.t0);

                debug.info("Commits (attached to PRs) fetched: " + allPRCommits.length);

                // get a list of commits not part of any pull requests
                // and not in the form of "Merge pull request #"
                // and not part of any automatic release
                independentCommits = allCommits.filter(function (commit) {
                  return !commit.message.match(/^Merge pull request #/);
                }).filter(function (commit) {
                  return !commit.message.match(/^Automated Release: v/i);
                }).filter(function (commit) {
                  return !commit.message.match(/\[ci skip\]/);
                }).filter(function (commit) {
                  return !commit.message.match(/\[skip ci\]/);
                }).filter(function (commit) {
                  return !(0, _lodash.find)(allPRCommits, function (prc) {
                    return prc === commit.sha;
                  });
                });
                theTimeline = (0, _lodash.orderBy)([].concat((0, _toConsumableArray3.default)(allIssues), (0, _toConsumableArray3.default)(independentCommits)), ['date'], ['asc']);


                this.timeline = theTimeline;

                return _context8.abrupt("return", theTimeline);

              case 23:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function getRepoTimeline() {
        return _ref8.apply(this, arguments);
      }

      return getRepoTimeline;
    }()
  }, {
    key: "getIncrementFromIssueLabels",
    value: function getIncrementFromIssueLabels(issue) {
      var _this2 = this;

      var regex = new RegExp("^" + this.config["major-label"] + "|^" + this.config["minor-label"] + "|^" + this.config["patch-label"]);
      // commits won't have labels property
      return issue.labels ? issue.labels.map(function (label) {
        return label.name;
      }).filter(function (name) {
        return name.match(regex);
      }).map(function (increment) {
        return _this2.incrementMap[increment];
      }).shift() : undefined;
      ;
    }

    // not static because we need the config option passed into the constructor

  }, {
    key: "getVersionFromTimeline",
    value: function getVersionFromTimeline(timeline) {
      var _this3 = this;

      var version = this.config.startVersion || "0.0.0";

      timeline.forEach(function (event) {
        var increment = _this3.getIncrementFromIssueLabels(event);
        version = Version.incrementVersion(increment, version);
      });

      return version;
    }
  }, {
    key: "getChangeLogContents",
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9() {
        var _this4 = this;

        var githubapi, allEvents, lines, version, lastEventDate;
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                githubapi = new _Github2.default(Version.getUserRepo());
                _context9.next = 3;
                return this.getRepoTimeline();

              case 3:
                allEvents = _context9.sent;
                lines = [];
                version = this.config.startVersion || "0.0.0";
                lastEventDate = (0, _moment2.default)(allEvents[0].date).format("YYYY-MM-DD");


                allEvents.forEach(function (issue) {
                  var currentEventDate = (0, _moment2.default)(issue.date).format("YYYY-MM-DD");

                  if (currentEventDate !== lastEventDate) {
                    lines.push("\n## " + lastEventDate + "\n\n");
                  }

                  var increment = _this4.getIncrementFromIssueLabels(issue);

                  version = Version.incrementVersion(increment, version);

                  lines.push(Version.getChangeLogLine(version, issue) + "\n");

                  lastEventDate = currentEventDate;
                });

                lines.push("## " + lastEventDate + " - [" + version + " - current version]\n\n");

                lines.push(Version.getChangeLogHeader());

                return _context9.abrupt("return", (0, _lodash.reverse)(lines));

              case 11:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function getChangeLogContents() {
        return _ref9.apply(this, arguments);
      }

      return getChangeLogContents;
    }()
  }, {
    key: "appendChangeLog",
    value: function appendChangeLog(newVersion, lastChange) {
      if (this.options.dryRun) {
        return debug.warn("[DRY RUN] appending \"" + Version.getChangeLogLine(newVersion, lastChange) + "\" to CHANGELOG");
      }

      var contents = _fsExtra2.default.readFileSync("CHANGELOG.md", "utf8", function (err, data) {
        if (err) {
          throw err;
        }

        return data;
      });

      if (!contents) {
        return debug.warn("Skipping appending CHANGELOG.md -- can't find a current CHANGELOG\"");
      }

      var lines = contents.split("\n");

      var newLines = lines.slice(0, 5);
      newLines.push("## " + (0, _moment2.default)().format("YYYY-MM-DD") + " - [" + newVersion + " - current version]");
      newLines.push("");
      newLines.push(Version.getChangeLogLine(newVersion, lastChange));

      // if latest change is the same date
      if ((0, _moment2.default)(lines[5].slice(3, 13)).isSame((0, _moment2.default)(), "day")) {
        newLines = newLines.concat(lines.slice(7));
      } else {
        newLines.push("");
        newLines.push(lines[5].slice(0, 13));
        newLines = newLines.concat(lines.slice(6));
      }

      this.writeChangeLog(newLines.map(function (line) {
        return line + "\n";
      }));
    }
  }, {
    key: "calculateCurrentVersion",
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee10() {
        var allEvents;
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this.getRepoTimeline();

              case 2:
                allEvents = _context10.sent;
                return _context10.abrupt("return", this.getVersionFromTimeline(allEvents));

              case 4:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function calculateCurrentVersion() {
        return _ref10.apply(this, arguments);
      }

      return calculateCurrentVersion;
    }()
  }, {
    key: "writeChangeLog",
    value: function writeChangeLog(lines) {
      if (this.options.dryRun) {
        debug.warn("[DRY RUN] writing changelog");
        return debug.warn((0, _lodash.join)(lines, ""));
      }

      _fsExtra2.default.writeFileSync("CHANGELOG.md", (0, _lodash.join)(lines, ""), { encoding: "utf8" }, function (err) {
        if (err) {
          throw new Error("Problem writing CHANGELOG.md to file!");
        }
      });
    }
  }, {
    key: "commitRefreshedChanges",
    value: function commitRefreshedChanges(version) {
      var cmd = "npm version " + version + " --no-git-tag-version";

      if (this.options.dryRun) {
        return debug.warn("[DRY RUN] Executing " + cmd);
      }

      var branch = Version.getBranch();

      Version.exec("git checkout " + branch);
      Version.exec(cmd, { stdio: "ignore" });
      Version.exec("git add package.json");
      Version.exec("git add CHANGELOG.md");

      Version.exec("git commit -m \"Automated release: v" + version + "\n\n[ci skip]\"");
      Version.exec("git tag v" + version);
    }
  }, {
    key: "release",


    // meant to be used after a successful CI build.
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee11() {
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this.increment();

              case 2:
                if (!this.shouldPush) {
                  _context11.next = 8;
                  break;
                }

                _context11.next = 5;
                return this.push();

              case 5:
                if (!this.shouldPublish) {
                  _context11.next = 8;
                  break;
                }

                _context11.next = 8;
                return this.publish();

              case 8:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function release() {
        return _ref11.apply(this, arguments);
      }

      return release;
    }()

    // meant to be used as a one off refresh of the changelog generation and version calculation

  }, {
    key: "refresh",
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee12() {
        var version, changeLog;
        return _regenerator2.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this.calculateCurrentVersion();

              case 2:
                version = _context12.sent;
                _context12.next = 5;
                return this.getChangeLogContents();

              case 5:
                changeLog = _context12.sent;

                if (Version.validVersionBump(this.config.version, version)) {
                  _context12.next = 8;
                  break;
                }

                throw new Error("The current version listed in package.json (" + this.config.version + ") is >= the calculated version (" + version + ")");

              case 8:

                this.writeChangeLog(changeLog);

                if (!this.shouldPush) {
                  _context12.next = 16;
                  break;
                }

                this.commitRefreshedChanges(version);
                _context12.next = 13;
                return this.push();

              case 13:
                if (!this.shouldPublish) {
                  _context12.next = 16;
                  break;
                }

                _context12.next = 16;
                return this.publish();

              case 16:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function refresh() {
        return _ref12.apply(this, arguments);
      }

      return refresh;
    }()
  }], [{
    key: "exec",
    value: function exec(cmd) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      debug.info("Executing: " + cmd);

      // Execute command, split lines, & trim empty ones
      var output = (0, _child_process.execSync)(cmd, (0, _extends3.default)({
        env: process.env
      }, options));

      return (output || "").toString().split(_os.EOL).filter(Boolean);
    }
  }, {
    key: "getBranch",
    value: function getBranch() {
      var branch = process.env.BRANCH || process.env.CIRCLE_BRANCH || process.env.TRAVIS_BRANCH;

      if (branch) {
        return branch;
      }

      var headFile = _path2.default.join(process.cwd(), ".git", "HEAD");
      var headContents = _fsExtra2.default.readFileSync(headFile, "utf8");

      var _ref13 = headContents.match(/ref: refs\/heads\/([^\n]+)/) || [],
          _ref14 = (0, _slicedToArray3.default)(_ref13, 2),
          _ = _ref14[0],
          name = _ref14[1];

      return name;
    }
  }, {
    key: "getCommitRange",
    value: function getCommitRange() {
      return [Version.getLatestTag() || Version.getInitialCommit(), "HEAD"].join("..");
    }
  }, {
    key: "getInitialCommit",
    value: function getInitialCommit() {
      return Version.exec("git log --format=%h --max-parents=0 HEAD").filter(Boolean).pop();
    }
  }, {
    key: "getLastCommit",
    value: function getLastCommit() {
      return Version.exec("git log -1 --format=%h HEAD").filter(Boolean).pop();
    }
  }, {
    key: "getLastPullRequest",
    value: function getLastPullRequest() {
      var range = Version.getCommitRange();
      var commit = Version.exec("git log --merges -n1 --format='%an|%ae|%s' " + range).shift();

      if (!commit) {
        debug.warn("No merge commits found between: %s", range);
        return null;
      }

      var _commit$split3 = commit.split("|"),
          _commit$split4 = (0, _slicedToArray3.default)(_commit$split3, 3),
          name = _commit$split4[0],
          email = _commit$split4[1],
          message = _commit$split4[2];

      if (!message) {
        return debug.error("Could not parse name, email, & message from: " + commit);
      }

      var _ref15 = message.match(/Merge pull request #(\d+)/) || [],
          _ref16 = (0, _slicedToArray3.default)(_ref15, 2),
          pr = _ref16[1];

      return pr;
    }
  }, {
    key: "getLatestTag",
    value: function getLatestTag() {
      var tag = Version.exec("git fetch --tags && git tag -l v*").filter(function (tag) {
        return tag.match(/^v(\d+)\.(\d+)\.(\d)/);
      }).pop();

      if (tag) {
        debug.info("Latest tag: %s", tag);
      } else {
        debug.warn("No tags found");
      }

      return tag || null;
    }
  }, {
    key: "getUserRepo",
    value: function getUserRepo() {
      var _Version$exec$shift$r = Version.exec("git config --get remote.origin.url").shift().replace(".git", "").split(/\/|:/).slice(-2),
          _Version$exec$shift$r2 = (0, _slicedToArray3.default)(_Version$exec$shift$r, 2),
          user = _Version$exec$shift$r2[0],
          repo = _Version$exec$shift$r2[1];

      debug.info("User: %s", user);
      debug.info("Repo: %s", repo);

      return { user: user, repo: repo };
    }
  }, {
    key: "sortItems",
    value: function sortItems(issues, afterDate) {
      var sortBy = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "date";
      var direction = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "desc";

      if (!issues) {
        return [];
      }

      var sorted = (0, _lodash.orderBy)(issues.filter(function (pr) {
        return afterDate ? (0, _moment2.default)(pr.closed_at).isAfter((0, _moment2.default)(afterDate)) : true;
      }), [sortBy], // sortBy
      [direction]);

      return sorted;
    }
  }, {
    key: "getChangeLogHeader",
    value: function getChangeLogHeader() {
      var headerLines = [];

      headerLines.push("# Change Log\n");
      headerLines.push("All notable changes to this project will be documented in this file.\n\n");
      headerLines.push("This project adheres to [Semantic Versioning](http://semver.org/).\n\n");

      return (0, _lodash.join)(headerLines, "");
    }
  }, {
    key: "incrementVersion",
    value: function incrementVersion(increment, version) {
      if (typeof version === "string") {
        version = version.split(".").map(function (v) {
          return Number(v);
        });
      }

      switch (increment) {
        case "major":
          return [version[0] + 1, 0, 0].join(".");
        case "minor":
          return [version[0], version[1] + 1, 0].join(".");
        default:
          return [version[0], version[1], version[2] + 1].join(".");
      }
    }
  }, {
    key: "getChangeLogLine",
    value: function getChangeLogLine(version, issue) {
      var issueNumber = issue.number ? "[" + issue.number + "]" : "[" + issue.sha.slice(0, 7) + "]";
      var issueUrl = "(" + issue.url + ")";
      var title = "" + (issue.title ? issue.title : issue.message.replace(/\n/g, " "));
      var user = issue.user ? "(@" + issue.user + ")" : "(" + issue.userName + ")";

      return "- " + version + " - (" + issueNumber + issueUrl + ") - " + title + " " + user;
    }
  }, {
    key: "validVersionBump",
    value: function validVersionBump(oldVersion, newVersion) {
      var oldParts = oldVersion.split(".");
      var newParts = newVersion.split(".");

      if (oldParts.length != newParts.length || oldParts.length != 3) {
        return false;
      }

      if (newParts[0] > oldParts[0]) {
        return true;
      } else if (newParts[0] === oldParts[0] && newParts[1] > oldParts[1]) {
        return true;
      } else if (newParts[0] === oldParts[0] && newParts[1] === oldParts[1] && newParts[2] > oldParts[2]) {
        return true;
      }

      return false;
    }
  }]);
  return Version;
}();

Version.defaultOptions = {
  branch: "master"
};
Version.INCREMENT_MAJOR = "major";
Version.INCREMENT_MINOR = "minor";
Version.INCREMENT_PATCH = "patch";
exports.default = Version;
;